=== debian/changelog ===
cgal (6.1.1-2) unstable; urgency=medium

  * Remove libboost-system-dev from Build-Depends: and Depends:
    (Closes: #1127178).

 -- Joachim Reichel <reichel@debian.org>  Fri, 06 Feb 2026 16:13:13 +0100

cgal (6.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Joachim Reichel <reichel@debian.org>  Mon, 26 Jan 2026 16:50:20 +0100
